ModuleEntry (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.classfile.constantpool, interface: ModuleEntry
Keywords: java.lang.classfile.constantpool.ModuleEntry interface

# Interface ModuleEntry

All Superinterfaces:
  `PoolEntry`

public sealed interface ModuleEntry extends PoolEntry
Models a `CONSTANT_Module_info` structure, denoting a module, in the constant pool of a `class` file.

The use of a `ModuleEntry` is modeled by a `ModuleDesc`. Conversions are through `ConstantPoolBuilder.moduleEntry(ModuleDesc)` and `asSymbol()`.

A module entry is composite:

    ModuleEntry(Utf8Entry name)

where `name` is a module name.

See Java Virtual Machine Specification:
  4.4.11 The `CONSTANT_Module_info` Structure
Since:
  24

- ## Field Summary

  ### Fields declared in interface PoolEntry

  `TAG_CLASS, TAG_DOUBLE, TAG_DYNAMIC, TAG_FIELDREF, TAG_FLOAT, TAG_INTEGER, TAG_INTERFACE_METHODREF, TAG_INVOKE_DYNAMIC, TAG_LONG, TAG_METHOD_HANDLE, TAG_METHOD_TYPE, TAG_METHODREF, TAG_MODULE, TAG_NAME_AND_TYPE, TAG_PACKAGE, TAG_STRING, TAG_UTF8`
  Modifier and Type
  Field
  Description
  `static final int`
  `TAG_CLASS`
  The tag for `CONSTANT_Class` constant kind.
  `static final int`
  `TAG_DOUBLE`
  The tag for `CONSTANT_Double` constant kind.
  `static final int`
  `TAG_DYNAMIC`
  The tag for `CONSTANT_Dynamic` constant kind.
  `static final int`
  `TAG_FIELDREF`
  The tag for `CONSTANT_Fieldref` constant kind.
  `static final int`
  `TAG_FLOAT`
  The tag for `CONSTANT_Float` constant kind.
  `static final int`
  `TAG_INTEGER`
  The tag for `CONSTANT_Integer` constant kind.
  `static final int`
  `TAG_INTERFACE_METHODREF`
  The tag for `CONSTANT_InterfaceMethodref` constant kind.
  `static final int`
  `TAG_INVOKE_DYNAMIC`
  The tag for `CONSTANT_InvokeDynamic` constant kind.
  `static final int`
  `TAG_LONG`
  The tag for `CONSTANT_Long` constant kind.
  `static final int`
  `TAG_METHOD_HANDLE`
  The tag for `CONSTANT_MethodHandle` constant kind.
  `static final int`
  `TAG_METHOD_TYPE`
  The tag for `CONSTANT_MethodType` constant kind.
  `static final int`
  `TAG_METHODREF`
  The tag for `CONSTANT_Methodref` constant kind.
  `static final int`
  `TAG_MODULE`
  The tag for `CONSTANT_Module` constant kind.
  `static final int`
  `TAG_NAME_AND_TYPE`
  The tag for `CONSTANT_NameAndType` constant kind.
  `static final int`
  `TAG_PACKAGE`
  The tag for `CONSTANT_Package` constant kind.
  `static final int`
  `TAG_STRING`
  The tag for `CONSTANT_String` constant kind.
  `static final int`
  `TAG_UTF8`
  The tag for `CONSTANT_Utf8` constant kind.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ModuleDesc`
  `asSymbol()`
  Returns a symbolic descriptor for the module name.
  `boolean`
  `matches(ModuleDesc desc)`
  Returns whether this entry describes the given module.
  `Utf8Entry`
  `name()`
  Returns the name of the module.

  ### Methods declared in interface PoolEntry

  `constantPool, index, tag, width`
  Modifier and Type
  Method
  Description
  `ConstantPool`
  `constantPool()`
  Returns the constant pool this entry is from.
  `int`
  `index()`
  Returns the index within the constant pool corresponding to this entry.
  `int`
  `tag()`
  Returns the constant pool tag that describes the type of this entry.
  `int`
  `width()`
  Returns the number of constant pool slots this entry consumes.

- ## Method Details

  - ### name

    Utf8Entry name()
    Returns the name of the module.
    Returns:
      the name of the module

  - ### asSymbol

    ModuleDesc asSymbol()
    Returns a symbolic descriptor for the module name.
    API Note:
      If only symbol equivalence is desired, `matches` should be used. It requires reduced parsing and can improve `class` file reading performance.
    Returns:
      a symbolic descriptor for the module name

  - ### matches

    boolean matches(ModuleDesc desc)
    Returns whether this entry describes the given module.
    Parameters:
      `desc` - the module descriptor
    Returns:
      whether this entry describes the given module
    Since:
      25